/*  libbadpenguin -- generic library for Bad Penguin development
 *
 *  Copyright (C) 1996 Antonio Gallo
 *  agx@linux.it
 *  
 *  Newer versions should be on www.badpenguin.org
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 */

#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "badpenguin-ansi.h"
#include "badpenguin-errors.h"
#include "badpenguin-fs.h"


// do the same as the shell command: mkdir -P -m
int makedir( char* s, mode_t m ) {
  char *f;
  if( s == NULL ) {
    fprintf(stderr, "makedir: NULL pointer detected!");
    return 0;
  }
  // Controllo se la directory esiste gia'
  if ( 0 == file_exists(s) ) return 0;
  // Controllo se il padre esiste
  f = dirpath(s);
  if ( 0 != file_exists( f ) ) {
    printWARNING("makedir: %s does not exists !\n", f );
    normal_color();
    if ( 0 != makedir( f, m ) ) {
      printERROR("makedir: error creating %s !\n", f );
      normal_color();
      return ERROR_IO;
    }
  }
  // L'albero del padre e' stato creato, puoi creare la foglia
  return mkdir( s, m );
}

